Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions

# NurbsCurveResult Class Reference

The result of a NurbsCurveEvaluator. More...

Inheritance diagram for NurbsCurveResult:

List of all members.

## Public Member Functions
| adaptiveSample (float tolerance)
| Determines the set of subdivisions necessary to approximate the curve with a set of linear segments, no point of which is farther than tolerance units from the actual curve.
float | evalExtendedPoint (float t, int d)
| Evaluates the curve in n-dimensional space according to the extended vertices associated with the curve in the indicated dimension.
bool | evalPoint (float t, VBase3 point)
| Computes the point on the curve corresponding to the indicated value in parametric time.
float | evalSegmentExtendedPoint (int segment, float t, int d)
| Evaluates the curve in n-dimensional space according to the extended vertices associated with the curve in the indicated dimension.
| evalSegmentPoint (int segment, float t, VBase3 point)
| Evaluates the point on the curve corresponding to the indicated value in parametric time within the indicated curve segment.
| evalSegmentTangent (int segment, float t, VBase3 tangent)
| As eval_segment_point, but computes the tangent to the curve at the indicated point.
bool | evalTangent (float t, VBase3 tangent)
| Computes the tangent to the curve at the indicated point in parametric time.
float | getEndT ()
| Returns the last legal value of t on the curve.
int | getNumSamples ()
| Returns the number of sample points generated by the previous call to adaptive_sample().
int | getNumSegments ()
| Returns the number of piecewise continuous segments within the curve.
Point3 const | getSamplePoint (int n)
| Returns the point on the curve of the nth sample point generated by the previous call to adaptive_sample().
list | getSamplePoints ()
float | getSampleT (int n)
| Returns the t value of the nth sample point generated by the previous call to adaptive_sample().
list | getSampleTs ()
float | getSegmentT (int segment, float t)
| Accepts a t value in the range [0, 1], and assumed to be relative to the indicated segment (as in eval_segment_point()), and returns the corresponding t value in the entire curve (as in eval_point()).
float | getStartT ()
| Returns the first legal value of t on the curve.

## Detailed Description

The result of a NurbsCurveEvaluator.

This object represents a curve in a particular coordinate space. It can return the point and/or tangent to the curve at any point.

This is not related to NurbsCurve, CubicCurveseg or any of the ParametricCurve-derived objects in this module. It is a completely parallel implementation of NURBS curves, and will probably eventually replace the whole ParametricCurve class hierarchy.

## Member Function Documentation

adaptiveSample | ( | float | tolerance | ) |

Determines the set of subdivisions necessary to approximate the curve with a set of linear segments, no point of which is farther than tolerance units from the actual curve.

After this call, you may walk through the resulting set of samples with get_num_samples(), get_sample_t(), and get_sample_point().

float evalExtendedPoint | ( | float | t,
|  | int | d
| ) |  |

Evaluates the curve in n-dimensional space according to the extended vertices associated with the curve in the indicated dimension.

bool evalPoint | ( | float | t,
|  | VBase3 | point
| ) |  |

Computes the point on the curve corresponding to the indicated value in parametric time.

Returns true if the t value is valid, false otherwise.

float evalSegmentExtendedPoint | ( | int | segment,
|  | float | t,
|  | int | d
| ) |  |

Evaluates the curve in n-dimensional space according to the extended vertices associated with the curve in the indicated dimension.

evalSegmentPoint | ( | int | segment,
|  | float | t,
|  | VBase3 | point
| ) |  |

Evaluates the point on the curve corresponding to the indicated value in parametric time within the indicated curve segment.

t should be in the range [0, 1].

The curve is internally represented as a number of connected (or possibly unconnected) piecewise continuous segments. The exact number of segments for a particular curve depends on the knot vector, and is returned by get_num_segments(). Normally, eval_point() is used to evaluate a point along the continuous curve, but when you care more about local continuity, you can use eval_segment_point() to evaluate the points along each segment.

evalSegmentTangent | ( | int | segment,
|  | float | t,
|  | VBase3 | tangent
| ) |  |

As eval_segment_point, but computes the tangent to the curve at the indicated point.

The tangent vector will not necessarily be normalized, and could be zero, particularly at the endpoints.

bool evalTangent | ( | float | t,
|  | VBase3 | tangent
| ) |  |

Computes the tangent to the curve at the indicated point in parametric time.

This tangent vector will not necessarily be normalized, and could be zero. See also eval_point().

float getEndT | ( |  | ) |

Returns the last legal value of t on the curve.

int getNumSamples | ( |  | ) |

Returns the number of sample points generated by the previous call to adaptive_sample().

int getNumSegments | ( |  | ) |

Returns the number of piecewise continuous segments within the curve.

This number is usually not important unless you plan to call eval_segment_point().

Point3 const getSamplePoint | ( | int | n | ) |

Returns the point on the curve of the nth sample point generated by the previous call to adaptive_sample().

For tangents, or extended points, you should use get_sample_t() and pass it into eval_tangent() or eval_extended_point().

list getSamplePoints | ( |  | ) |

float getSampleT | ( | int | n | ) |

Returns the t value of the nth sample point generated by the previous call to adaptive_sample().

list getSampleTs | ( |  | ) |

float getSegmentT | ( | int | segment,
|  | float | t
| ) |  |

Accepts a t value in the range [0, 1], and assumed to be relative to the indicated segment (as in eval_segment_point()), and returns the corresponding t value in the entire curve (as in eval_point()).

float getStartT | ( |  | ) |

Returns the first legal value of t on the curve.

Usually this is 0.0.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties